# Fxengine::Bitmap
This is part of the [fxengine](/Milang/fxengine) project.
This file refers to [fxengine/model/triangle.h](triangle.h) header.

## Dependencies
[bitmap.h](bitmap.h) ([doc](bitmap.md))
[vertex.h](vertex.h) ([doc](vertex.md))

## Presentation
The `fe_triangle` data structure is a way to display easily faces in fxengine. It helps while you are creating models, or just if you want to reduce code size.

## Detail 
```c
typedef struct
{
    fe_vertex * s1; // The 3 vertexes
    fe_vertex * s2;
    fe_vertex * s3;

    fe_bitmap * texture1; // side 1
    fe_bitmap * texture2; // side 2

    bool texture_half; // the half used for the textures
} fe_triangle;
```
