#include <fxengine/math.h>

static double reducted_cos(const double a)
{
    double u= 1.0;
    const double a2 = a * a;
    for(int32_t p = 17; p>=1; p -= 2)
        u = 1 - a2 / (p * p + p) * u;
    return u;
}

// return a with -pi<=a<pi
double fe_modulo_2pi(double a)
{
    while (a<=-pi)
      a += pi2;
  while (a>pi)
      a -= pi2;
  return a;
}

double fe_cos(double angle)
{
    angle = fe_modulo_2pi(angle);
    if (angle<0)
        angle=-angle;
    if (angle>=pi_sur_2)
        return -reducted_cos(angle - pi);
    else
    	return reducted_cos(angle);
}

double fe_sin(double angle)
{
	return fe_cos(angle - pi_sur_2);
}
